Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Operators/SingleObjectiveMoveMaker.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Operators/SingleObjectiveMoveMaker.cs	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Operators/SingleObjectiveMoveMaker.cs	(revision 16751)
@@ -21,4 +21,5 @@
 
 using System;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -26,13 +27,12 @@
 using HeuristicLab.Operators;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 
 namespace HeuristicLab.Optimization {
   [Item("Single-objective MoveMaker", "Applies a move.")]
   [StorableType("C0ABF392-C825-4B98-8FB9-5749A9091FD6")]
-  public class SingleObjectiveMoveMaker<TSolution> : InstrumentedOperator, IMoveMaker, ISingleObjectiveMoveOperator
-  where TSolution : class, ISolution {
-    public ILookupParameter<IEncoding<TSolution>> EncodingParameter {
-      get { return (ILookupParameter<IEncoding<TSolution>>)Parameters["Encoding"]; }
+  public class SingleObjectiveMoveMaker<TEncodedSolution> : InstrumentedOperator, IMoveMaker, ISingleObjectiveMoveOperator
+  where TEncodedSolution : class, IEncodedSolution {
+    public ILookupParameter<IEncoding<TEncodedSolution>> EncodingParameter {
+      get { return (ILookupParameter<IEncoding<TEncodedSolution>>)Parameters["Encoding"]; }
     }
 
@@ -47,7 +47,7 @@
     [StorableConstructor]
     protected SingleObjectiveMoveMaker(StorableConstructorFlag _) : base(_) { }
-    protected SingleObjectiveMoveMaker(SingleObjectiveMoveMaker<TSolution> original, Cloner cloner) : base(original, cloner) { }
+    protected SingleObjectiveMoveMaker(SingleObjectiveMoveMaker<TEncodedSolution> original, Cloner cloner) : base(original, cloner) { }
     public SingleObjectiveMoveMaker() {
-      Parameters.Add(new LookupParameter<IEncoding<TSolution>>("Encoding", "An item that holds the problem's encoding."));
+      Parameters.Add(new LookupParameter<IEncoding<TEncodedSolution>>("Encoding", "An item that holds the problem's encoding."));
       Parameters.Add(new LookupParameter<DoubleValue>("Quality", "The quality of the parameter vector."));
       Parameters.Add(new LookupParameter<DoubleValue>("MoveQuality", "The quality of the move."));
@@ -55,5 +55,5 @@
 
     public override IDeepCloneable Clone(Cloner cloner) {
-      return new SingleObjectiveMoveMaker<TSolution>(this, cloner);
+      return new SingleObjectiveMoveMaker<TEncodedSolution>(this, cloner);
     }
 
@@ -62,6 +62,6 @@
 
       var encoding = EncodingParameter.ActualValue;
-      var solution = ScopeUtil.GetSolution(ExecutionContext.Scope, encoding);
-      ScopeUtil.CopySolutionToScope(ExecutionContext.Scope.Parent.Parent, encoding, solution);
+      var solution = ScopeUtil.GetEncodedSolution(ExecutionContext.Scope, encoding);
+      ScopeUtil.CopyEncodedSolutionToScope(ExecutionContext.Scope.Parent.Parent, encoding, solution);
 
       if (QualityParameter.ActualValue == null) QualityParameter.ActualValue = new DoubleValue(MoveQualityParameter.ActualValue.Value);
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Problem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Problem.cs	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/Problem.cs	(revision 16751)
@@ -23,20 +23,20 @@
 using System.Collections.Generic;
 using System.Linq;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 
 namespace HeuristicLab.Optimization {
   [StorableType("D877082E-9E77-4CB1-ABDB-35F63878E116")]
-  public abstract class Problem<TEncoding, TSolution, TEvaluator> : Problem,
-    IHeuristicOptimizationProblem, IProblemDefinition<TEncoding, TSolution>, IStorableContent
-    where TEncoding : class, IEncoding<TSolution>
-    where TSolution : class, ISolution
+  public abstract class Problem<TEncoding, TEncodedSolution, TEvaluator> : Problem,
+    IHeuristicOptimizationProblem, IProblemDefinition<TEncoding, TEncodedSolution>, IStorableContent
+    where TEncoding : class, IEncoding<TEncodedSolution>
+    where TEncodedSolution : class, IEncodedSolution
     where TEvaluator : class, IEvaluator {
 
     public string Filename { get; set; } // TODO: Really okay here? should be in Problem (non-generic)
 
-    //TODO remove parametr for encoding?
+    //TODO remove parameter for encoding?
     protected IValueParameter<TEncoding> EncodingParameter {
       get { return (IValueParameter<TEncoding>)Parameters["Encoding"]; }
@@ -115,5 +115,5 @@
     }
 
-    protected Problem(Problem<TEncoding, TSolution, TEvaluator> original, Cloner cloner)
+    protected Problem(Problem<TEncoding, TEncodedSolution, TEvaluator> original, Cloner cloner)
       : base(original, cloner) {
       oldEncoding = cloner.Clone(original.oldEncoding);
@@ -152,5 +152,5 @@
       oldEncoding = Encoding;
 
-      foreach (var op in Operators.OfType<IEncodingOperator<TSolution>>())
+      foreach (var op in Operators.OfType<IEncodingOperator<TEncodedSolution>>())
         op.EncodingParameter.ActualName = EncodingParameter.Name;
 
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/SingleObjectiveProblem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/SingleObjectiveProblem.cs	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/BasicProblems/SingleObjectiveProblem.cs	(revision 16751)
@@ -23,18 +23,18 @@
 using System.Collections.Generic;
 using System.Linq;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 
 namespace HeuristicLab.Optimization {
   [StorableType("2697320D-0259-44BB-BD71-7EE1B10F664C")]
-  public abstract class SingleObjectiveProblem<TEncoding, TSolution> :
-    Problem<TEncoding, TSolution, SingleObjectiveEvaluator<TSolution>>,
-    ISingleObjectiveProblem<TEncoding, TSolution>,
-    ISingleObjectiveProblemDefinition<TEncoding, TSolution>
-    where TEncoding : class, IEncoding<TSolution>
-    where TSolution : class, ISolution {
+  public abstract class SingleObjectiveProblem<TEncoding, TEncodedSolution> :
+    Problem<TEncoding, TEncodedSolution, SingleObjectiveEvaluator<TEncodedSolution>>,
+    ISingleObjectiveProblem<TEncoding, TEncodedSolution>,
+    ISingleObjectiveProblemDefinition<TEncoding, TEncodedSolution>
+    where TEncoding : class, IEncoding<TEncodedSolution>
+    where TEncodedSolution : class, IEncodedSolution {
 
     protected IValueParameter<DoubleValue> BestKnownQualityParameter {
@@ -64,5 +64,5 @@
     protected SingleObjectiveProblem(StorableConstructorFlag _) : base(_) { }
 
-    protected SingleObjectiveProblem(SingleObjectiveProblem<TEncoding, TSolution> original, Cloner cloner)
+    protected SingleObjectiveProblem(SingleObjectiveProblem<TEncoding, TEncodedSolution> original, Cloner cloner)
       : base(original, cloner) {
       ParameterizeOperators();
@@ -75,9 +75,9 @@
 
       Operators.Add(Evaluator);
-      Operators.Add(new SingleObjectiveAnalyzer<TSolution>());
-      Operators.Add(new SingleObjectiveImprover<TSolution>());
-      Operators.Add(new SingleObjectiveMoveEvaluator<TSolution>());
-      Operators.Add(new SingleObjectiveMoveGenerator<TSolution>());
-      Operators.Add(new SingleObjectiveMoveMaker<TSolution>());
+      Operators.Add(new SingleObjectiveAnalyzer<TEncodedSolution>());
+      Operators.Add(new SingleObjectiveImprover<TEncodedSolution>());
+      Operators.Add(new SingleObjectiveMoveEvaluator<TEncodedSolution>());
+      Operators.Add(new SingleObjectiveMoveGenerator<TEncodedSolution>());
+      Operators.Add(new SingleObjectiveMoveMaker<TEncodedSolution>());
 
       ParameterizeOperators();
@@ -90,9 +90,9 @@
 
       Operators.Add(Evaluator);
-      Operators.Add(new SingleObjectiveAnalyzer<TSolution>());
-      Operators.Add(new SingleObjectiveImprover<TSolution>());
-      Operators.Add(new SingleObjectiveMoveEvaluator<TSolution>());
-      Operators.Add(new SingleObjectiveMoveGenerator<TSolution>());
-      Operators.Add(new SingleObjectiveMoveMaker<TSolution>());
+      Operators.Add(new SingleObjectiveAnalyzer<TEncodedSolution>());
+      Operators.Add(new SingleObjectiveImprover<TEncodedSolution>());
+      Operators.Add(new SingleObjectiveMoveEvaluator<TEncodedSolution>());
+      Operators.Add(new SingleObjectiveMoveGenerator<TEncodedSolution>());
+      Operators.Add(new SingleObjectiveMoveMaker<TEncodedSolution>());
 
       ParameterizeOperators();
@@ -105,8 +105,8 @@
 
     public abstract bool Maximization { get; }
-    public abstract double Evaluate(TSolution solution, IRandom random);
-    public virtual void Analyze(TSolution[] solutions, double[] qualities, ResultCollection results, IRandom random) { }
-    public virtual IEnumerable<TSolution> GetNeighbors(TSolution solution, IRandom random) {
-      return Enumerable.Empty<TSolution>();
+    public abstract double Evaluate(TEncodedSolution solution, IRandom random);
+    public virtual void Analyze(TEncodedSolution[] solutions, double[] qualities, ResultCollection results, IRandom random) { }
+    public virtual IEnumerable<TEncodedSolution> GetNeighbors(TEncodedSolution solution, IRandom random) {
+      return Enumerable.Empty<TEncodedSolution>();
     }
 
@@ -115,8 +115,8 @@
     }
 
-    protected Tuple<TSolution, double> GetBestSolution(TSolution[] solutions, double[] qualities) {
+    protected Tuple<TEncodedSolution, double> GetBestSolution(TEncodedSolution[] solutions, double[] qualities) {
       return GetBestSolution(solutions, qualities, Maximization);
     }
-    public static Tuple<TSolution, double> GetBestSolution(TSolution[] solutions, double[] qualities, bool maximization) {
+    public static Tuple<TEncodedSolution, double> GetBestSolution(TEncodedSolution[] solutions, double[] qualities, bool maximization) {
       var zipped = solutions.Zip(qualities, (s, q) => new { Solution = s, Quality = q });
       var best = (maximization ? zipped.OrderByDescending(z => z.Quality) : zipped.OrderBy(z => z.Quality)).First();
@@ -154,9 +154,9 @@
 
     private void ParameterizeOperators() {
-      foreach (var op in Operators.OfType<ISingleObjectiveEvaluationOperator<TSolution>>())
+      foreach (var op in Operators.OfType<ISingleObjectiveEvaluationOperator<TEncodedSolution>>())
         op.EvaluateFunc = Evaluate;
-      foreach (var op in Operators.OfType<ISingleObjectiveAnalysisOperator<TSolution>>())
+      foreach (var op in Operators.OfType<ISingleObjectiveAnalysisOperator<TEncodedSolution>>())
         op.AnalyzeAction = Analyze;
-      foreach (var op in Operators.OfType<INeighborBasedOperator<TSolution>>())
+      foreach (var op in Operators.OfType<INeighborBasedOperator<TEncodedSolution>>())
         op.GetNeighborsFunc = GetNeighbors;
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/HeuristicLab.Optimization-3.3.csproj	(revision 16751)
@@ -143,5 +143,5 @@
     <Compile Include="BasicProblems\Interfaces\ISingleObjectiveMoveOperator.cs" />
     <Compile Include="BasicProblems\Interfaces\ISingleObjectiveProblemDefinition.cs" />
-    <Compile Include="BasicProblems\Interfaces\ISolution.cs" />
+    <Compile Include="BasicProblems\Interfaces\IEncodedSolution.cs" />
     <Compile Include="BasicProblems\MultiObjectiveProblem.cs" />
     <Compile Include="BasicProblems\Operators\MultiObjectiveAnalyzer.cs" />
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Interfaces/IProblem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Interfaces/IProblem.cs	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Interfaces/IProblem.cs	(revision 16751)
@@ -22,6 +22,6 @@
 using System;
 using System.Collections.Generic;
+using HEAL.Attic;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Optimization {
@@ -38,7 +38,7 @@
   }
 
-  public interface IProblem<TEncoding, TSolution> : IHeuristicOptimizationProblem
-    where TEncoding : class, IEncoding<TSolution>
-    where TSolution : class, ISolution {
+  public interface IProblem<TEncoding, TEncodedSolution> : IHeuristicOptimizationProblem
+    where TEncoding : class, IEncoding<TEncodedSolution>
+    where TEncodedSolution : class, IEncodedSolution {
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Interfaces/ISolutionCreator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Interfaces/ISolutionCreator.cs	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Optimization/3.3/Interfaces/ISolutionCreator.cs	(revision 16751)
@@ -20,6 +20,6 @@
 #endregion
 
+using HEAL.Attic;
 using HeuristicLab.Core;
-using HEAL.Attic;
 
 namespace HeuristicLab.Optimization {
@@ -30,6 +30,6 @@
   public interface ISolutionCreator : IOperator { }
 
-  public interface ISolutionCreator<TSolution> : ISolutionCreator where TSolution : class, ISolution {
-    //ILookupParameter<TSolution> SolutionParameter { get; } // TODO: unify encoding specific parameters by defining ISolutionOperator and ISolutionsOperator
+  public interface ISolutionCreator<TEncodedSolution> : ISolutionCreator where TEncodedSolution : class, IEncodedSolution {
+    //ILookupParameter<TEncodedSolution> SolutionParameter { get; } // TODO: unify encoding specific parameters by defining ISolutionOperator and ISolutionsOperator
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/ExternalEvaluationProblem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/ExternalEvaluationProblem.cs	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/ExternalEvaluationProblem.cs	(revision 16751)
@@ -40,5 +40,5 @@
   // BackwardsCompatibility3.3
   // Rename class to SingleObjectiveExternalEvaluationProblem
-  public class ExternalEvaluationProblem : SingleObjectiveProblem<IEncoding<ISolution>, ISolution>, IExternalEvaluationProblem {
+  public class ExternalEvaluationProblem : SingleObjectiveProblem<IEncoding<IEncodedSolution>, IEncodedSolution>, IExternalEvaluationProblem {
 
     public static new Image StaticItemImage {
@@ -66,5 +66,5 @@
 
     #region Properties
-    public new IEncoding<ISolution> Encoding {
+    public new IEncoding<IEncodedSolution> Encoding {
       get { return base.Encoding; }
       set { base.Encoding = value; }
@@ -114,5 +114,5 @@
     }
 
-    public override double Evaluate(ISolution individual, IRandom random) {
+    public override double Evaluate(IEncodedSolution individual, IRandom random) {
       var qualityMessage = Evaluate(BuildSolutionMessage(individual));
       if (!qualityMessage.HasExtension(SingleObjectiveQualityMessage.QualityMessage_))
@@ -126,9 +126,9 @@
     }
 
-    public override void Analyze(ISolution[] individuals, double[] qualities, ResultCollection results, IRandom random) {
+    public override void Analyze(IEncodedSolution[] individuals, double[] qualities, ResultCollection results, IRandom random) {
       OptimizationSupport.Analyze(individuals, qualities, results, random);
     }
 
-    public override IEnumerable<ISolution> GetNeighbors(ISolution individual, IRandom random) {
+    public override IEnumerable<IEncodedSolution> GetNeighbors(IEncodedSolution individual, IRandom random) {
       return OptimizationSupport.GetNeighbors(individual, random);
     }
@@ -167,10 +167,10 @@
     }
 
-    private SolutionMessage BuildSolutionMessage(ISolution solution, int solutionId = 0) {
+    private SolutionMessage BuildSolutionMessage(IEncodedSolution solution, int solutionId = 0) {
       lock (clientLock) {
         SolutionMessage.Builder protobufBuilder = SolutionMessage.CreateBuilder();
         protobufBuilder.SolutionId = solutionId;
         var scope = new Scope();
-        ScopeUtil.CopySolutionToScope(scope, Encoding, solution);
+        ScopeUtil.CopyEncodedSolutionToScope(scope, Encoding, solution);
         foreach (var variable in scope.Variables) {
           try {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Interfaces/IMultiObjectiveOptimizationSupport.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Interfaces/IMultiObjectiveOptimizationSupport.cs	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Interfaces/IMultiObjectiveOptimizationSupport.cs	(revision 16751)
@@ -27,5 +27,5 @@
   [StorableType("f924ef9c-d824-40d2-89b2-6dd1220df98b")]
   public interface IMultiObjectiveOptimizationSupport {
-    void Analyze(ISolution[] individuals, double[][] qualities, ResultCollection results, IRandom random);
+    void Analyze(IEncodedSolution[] individuals, double[][] qualities, ResultCollection results, IRandom random);
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Interfaces/ISingleObjectiveOptimizationSupport.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Interfaces/ISingleObjectiveOptimizationSupport.cs	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Interfaces/ISingleObjectiveOptimizationSupport.cs	(revision 16751)
@@ -28,6 +28,6 @@
   [StorableType("09d522e0-c10f-474c-b7c0-7d7f98e63f44")]
   public interface ISingleObjectiveOptimizationSupport {
-    void Analyze(ISolution[] individuals, double[] qualities, ResultCollection results, IRandom random);
-    IEnumerable<ISolution> GetNeighbors(ISolution individual, IRandom random);
+    void Analyze(IEncodedSolution[] individuals, double[] qualities, ResultCollection results, IRandom random);
+    IEnumerable<IEncodedSolution> GetNeighbors(IEncodedSolution individual, IRandom random);
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/MultiObjectiveExternalEvaluationProblem.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/MultiObjectiveExternalEvaluationProblem.cs	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/MultiObjectiveExternalEvaluationProblem.cs	(revision 16751)
@@ -37,5 +37,5 @@
   [Creatable(CreatableAttribute.Categories.ExternalEvaluationProblems, Priority = 200)]
   [StorableType("CCA50199-A6AB-4C84-B4FA-0262CAF416EC")]
-  public class MultiObjectiveExternalEvaluationProblem : MultiObjectiveProblem<IEncoding<ISolution>, ISolution>, IExternalEvaluationProblem {
+  public class MultiObjectiveExternalEvaluationProblem : MultiObjectiveProblem<IEncoding<IEncodedSolution>, IEncodedSolution>, IExternalEvaluationProblem {
 
     public static new Image StaticItemImage {
@@ -63,5 +63,5 @@
 
     #region Properties
-    public new IEncoding<ISolution> Encoding {
+    public new IEncoding<IEncodedSolution> Encoding {
       get { return base.Encoding; }
       set { base.Encoding = value; }
@@ -114,5 +114,5 @@
     }
 
-    public override double[] Evaluate(ISolution individual, IRandom random) {
+    public override double[] Evaluate(IEncodedSolution individual, IRandom random) {
       var qualityMessage = Evaluate(BuildSolutionMessage(individual));
       if (!qualityMessage.HasExtension(MultiObjectiveQualityMessage.QualityMessage_))
@@ -126,5 +126,5 @@
     }
 
-    public override void Analyze(ISolution[] individuals, double[][] qualities, ResultCollection results, IRandom random) {
+    public override void Analyze(IEncodedSolution[] individuals, double[][] qualities, ResultCollection results, IRandom random) {
       OptimizationSupport.Analyze(individuals, qualities, results, random);
     }
@@ -164,10 +164,10 @@
     }
 
-    private SolutionMessage BuildSolutionMessage(ISolution solution, int solutionId = 0) {
+    private SolutionMessage BuildSolutionMessage(IEncodedSolution solution, int solutionId = 0) {
       lock (clientLock) {
         SolutionMessage.Builder protobufBuilder = SolutionMessage.CreateBuilder();
         protobufBuilder.SolutionId = solutionId;
         var scope = new Scope();
-        ScopeUtil.CopySolutionToScope(scope, Encoding, solution);
+        ScopeUtil.CopyEncodedSolutionToScope(scope, Encoding, solution);
         foreach (var variable in scope.Variables) {
           try {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Programmable/CompiledMultiObjectiveOptimizationSupport.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Programmable/CompiledMultiObjectiveOptimizationSupport.cs	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Programmable/CompiledMultiObjectiveOptimizationSupport.cs	(revision 16751)
@@ -5,5 +5,5 @@
   public class CompiledMultiObjectiveOptimizationSupport : CompiledOptimizationSupport, IMultiObjectiveOptimizationSupport {
 
-    public void Analyze(ISolution[] individuals, double[][] qualities, ResultCollection results, IRandom random) {
+    public void Analyze(IEncodedSolution[] individuals, double[][] qualities, ResultCollection results, IRandom random) {
       // Use vars.yourVariable to access variables in the variable store i.e. yourVariable
       // Write or update results given the range of vectors and resulting qualities
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Programmable/CompiledSingleObjectiveOptimizationSupport.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Programmable/CompiledSingleObjectiveOptimizationSupport.cs	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Programmable/CompiledSingleObjectiveOptimizationSupport.cs	(revision 16751)
@@ -6,5 +6,5 @@
   public class CompiledSingleObjectiveOptimizationSupport : CompiledOptimizationSupport, ISingleObjectiveOptimizationSupport {
 
-    public void Analyze(ISolution[] individuals, double[] qualities, ResultCollection results, IRandom random) {
+    public void Analyze(IEncodedSolution[] individuals, double[] qualities, ResultCollection results, IRandom random) {
       // Use vars.yourVariable to access variables in the variable store i.e. yourVariable
       // Write or update results given the range of vectors and resulting qualities
@@ -17,5 +17,5 @@
     }
 
-    public IEnumerable<ISolution> GetNeighbors(ISolution individual, IRandom random) {
+    public IEnumerable<IEncodedSolution> GetNeighbors(IEncodedSolution individual, IRandom random) {
       // Use vars.yourVariable to access variables in the variable store i.e. yourVariable
       // Create new vectors, based on the given one that represent small changes
@@ -24,5 +24,5 @@
         // Algorithm will draw only a finite amount of samples
         // Change to a for-loop to return a concrete amount of neighbors
-        var neighbor = (ISolution)individual.Clone();
+        var neighbor = (IEncodedSolution)individual.Clone();
         // For instance, perform a single bit-flip in a binary parameter
         //var bIndex = random.Next(neighbor.BinaryVector("b").Length);
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Programmable/MultiObjectiveOptimizationSupportScript.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Programmable/MultiObjectiveOptimizationSupportScript.cs	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Programmable/MultiObjectiveOptimizationSupportScript.cs	(revision 16751)
@@ -39,5 +39,5 @@
     }
 
-    void IMultiObjectiveOptimizationSupport.Analyze(ISolution[] individuals, double[][] qualities, ResultCollection results, IRandom random) {
+    void IMultiObjectiveOptimizationSupport.Analyze(IEncodedSolution[] individuals, double[][] qualities, ResultCollection results, IRandom random) {
       CompiledInstance.Analyze(individuals, qualities, results, random);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Programmable/SingleObjectiveOptimizationSupportScript.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Programmable/SingleObjectiveOptimizationSupportScript.cs	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.ExternalEvaluation/3.4/Programmable/SingleObjectiveOptimizationSupportScript.cs	(revision 16751)
@@ -40,9 +40,9 @@
     }
 
-    void ISingleObjectiveOptimizationSupport.Analyze(ISolution[] individuals, double[] qualities, ResultCollection results, IRandom random) {
+    void ISingleObjectiveOptimizationSupport.Analyze(IEncodedSolution[] individuals, double[] qualities, ResultCollection results, IRandom random) {
       CompiledInstance.Analyze(individuals, qualities, results, random);
     }
 
-    IEnumerable<ISolution> ISingleObjectiveOptimizationSupport.GetNeighbors(ISolution individual, IRandom random) {
+    IEnumerable<IEncodedSolution> ISingleObjectiveOptimizationSupport.GetNeighbors(IEncodedSolution individual, IRandom random) {
       return CompiledInstance.GetNeighbors(individual, random);
     }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/CompiledProblemDefinition.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/CompiledProblemDefinition.cs	(revision 16750)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Programmable/3.3/CompiledProblemDefinition.cs	(revision 16751)
@@ -26,7 +26,7 @@
 
 namespace HeuristicLab.Problems.Programmable {
-  public abstract class CompiledProblemDefinition<TEncoding, TSolution> : IProblemDefinition<TEncoding, TSolution>
-    where TEncoding : class, IEncoding<TSolution>
-    where TSolution : class, ISolution {
+  public abstract class CompiledProblemDefinition<TEncoding, TEncodedSolution> : IProblemDefinition<TEncoding, TEncodedSolution>
+    where TEncoding : class, IEncoding<TEncodedSolution>
+    where TEncodedSolution : class, IEncodedSolution {
     private TEncoding encoding;
     public TEncoding Encoding {
@@ -48,7 +48,7 @@
   }
 
-  public abstract class CompiledSingleObjectiveProblemDefinition<TEncoding, TSolution> : CompiledProblemDefinition<TEncoding, TSolution>, ISingleObjectiveProblemDefinition<TEncoding, TSolution>
-    where TEncoding : class, IEncoding<TSolution>
-    where TSolution : class, ISolution {
+  public abstract class CompiledSingleObjectiveProblemDefinition<TEncoding, TEncodedSolution> : CompiledProblemDefinition<TEncoding, TEncodedSolution>, ISingleObjectiveProblemDefinition<TEncoding, TEncodedSolution>
+    where TEncoding : class, IEncoding<TEncodedSolution>
+    where TEncodedSolution : class, IEncodedSolution {
 
     protected CompiledSingleObjectiveProblemDefinition() : base() { }
@@ -57,9 +57,9 @@
       : base(encoding) { }
 
-    #region ISingleObjectiveProblemDefinition<TEncoding,TSolution> Members
+    #region ISingleObjectiveProblemDefinition<TEncoding,TEncodedSolution> Members
     public abstract bool Maximization { get; }
-    public abstract double Evaluate(TSolution individual, IRandom random);
-    public abstract void Analyze(TSolution[] individuals, double[] qualities, ResultCollection results, IRandom random);
-    public abstract IEnumerable<TSolution> GetNeighbors(TSolution individual, IRandom random);
+    public abstract double Evaluate(TEncodedSolution individual, IRandom random);
+    public abstract void Analyze(TEncodedSolution[] individuals, double[] qualities, ResultCollection results, IRandom random);
+    public abstract IEnumerable<TEncodedSolution> GetNeighbors(TEncodedSolution individual, IRandom random);
 
     public bool IsBetter(double quality, double bestQuality) {
@@ -69,7 +69,7 @@
   }
 
-  public abstract class CompiledMultiObjectiveProblemDefinition<TEncoding, TSolution> : CompiledProblemDefinition<TEncoding, TSolution>, IMultiObjectiveProblemDefinition<TEncoding, TSolution>
-    where TEncoding : class, IEncoding<TSolution>
-    where TSolution : class, ISolution {
+  public abstract class CompiledMultiObjectiveProblemDefinition<TEncoding, TEncodedSolution> : CompiledProblemDefinition<TEncoding, TEncodedSolution>, IMultiObjectiveProblemDefinition<TEncoding, TEncodedSolution>
+    where TEncoding : class, IEncoding<TEncodedSolution>
+    where TEncodedSolution : class, IEncodedSolution {
 
     protected CompiledMultiObjectiveProblemDefinition() : base() { }
@@ -78,9 +78,9 @@
       : base(encoding) { }
 
-    #region ISingleObjectiveProblemDefinition<TEncoding,TSolution> Members
+    #region ISingleObjectiveProblemDefinition<TEncoding,TEncodedSolution> Members
     public abstract bool[] Maximization { get; }
-    public abstract double[] Evaluate(TSolution individual, IRandom random);
-    public abstract void Analyze(TSolution[] individuals, double[][] qualities, ResultCollection results, IRandom random);
-    public abstract IEnumerable<TSolution> GetNeighbors(TSolution individual, IRandom random);
+    public abstract double[] Evaluate(TEncodedSolution individual, IRandom random);
+    public abstract void Analyze(TEncodedSolution[] individuals, double[][] qualities, ResultCollection results, IRandom random);
+    public abstract IEnumerable<TEncodedSolution> GetNeighbors(TEncodedSolution individual, IRandom random);
     #endregion
   }
